package io.bdty.modules.cniyv.controller;

import io.bdty.common.annotation.LogOperation;
import io.bdty.common.constant.Constant;
import io.bdty.common.page.PageData;
import io.bdty.common.utils.ExcelUtils;
import io.bdty.common.utils.Result;
import io.bdty.common.validator.AssertUtils;
import io.bdty.common.validator.ValidatorUtils;
import io.bdty.common.validator.group.AddGroup;
import io.bdty.common.validator.group.DefaultGroup;
import io.bdty.common.validator.group.UpdateGroup;
import io.bdty.modules.cniyv.dto.CniyvArticleDTO;
import io.bdty.modules.cniyv.excel.CniyvArticleExcel;
import io.bdty.modules.cniyv.service.CniyvArticleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;


/**
 * 文章
 *
 * @author zxj zxj
 * @since 1.0.0 2024-03-13
 */
@RestController
@RequestMapping("cniyv/cniyvarticle")
@Api(tags="文章")
public class CniyvArticleController {
    @Autowired
    private CniyvArticleService cniyvArticleService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String")
    })
    public Result<PageData<CniyvArticleDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<CniyvArticleDTO> page = cniyvArticleService.page(params);

        return new Result<PageData<CniyvArticleDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("cniyv:cniyvarticle:info")
    public Result<CniyvArticleDTO> get(@PathVariable("id") Long id){
        CniyvArticleDTO data = cniyvArticleService.get(id);

        return new Result<CniyvArticleDTO>().ok(data);
    }
    
    @GetMapping("info/{id}")
    @ApiOperation("详情")
    public Result<CniyvArticleDTO> info(@PathVariable("id") Long id){
        CniyvArticleDTO data = cniyvArticleService.get(id);

        return new Result<CniyvArticleDTO>().ok(data);
    }

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    @RequiresPermissions("cniyv:cniyvarticle:save")
    public Result save(@RequestBody CniyvArticleDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        cniyvArticleService.save(dto);

        return new Result();
    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("cniyv:cniyvarticle:update")
    public Result update(@RequestBody CniyvArticleDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        cniyvArticleService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("cniyv:cniyvarticle:delete")
    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        cniyvArticleService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("cniyv:cniyvarticle:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<CniyvArticleDTO> list = cniyvArticleService.list(params);

        ExcelUtils.exportExcelToTarget(response, null, "文章", list, CniyvArticleExcel.class);
    }

}